> ## Documentation Index
> Fetch the complete documentation index at: https://meilisearch-6b28dec2-mintlify-code-samples.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Settings

> The /settings route allows you to customize search settings for the given index.

export const NoticeTag = ({label}) => <span className="noticeTag noticeTag--{ label }">
    {label}
  </span>;

export const RouteHighlighter = ({method, path}) => <div className={`routeHighlighter routeHighlighter--${method}`}>
    <div className="routeHighlighter__method">
      {method}
    </div>
    <div className="routeHighlighter__path">
      {path}
    </div>
  </div>;

Use the `/settings` route to customize search settings for a given index. You can either modify all index settings at once using the [update settings endpoint](#update-settings), or use a child route to configure a single setting.

For a conceptual overview of index settings, refer to the [indexes explanation](/learn/getting_started/indexes#index-settings). To learn more about the basics of index configuration, refer to the [index configuration tutorial](/learn/configuration/configuring_index_settings_api).

## Settings interface

[Meilisearch Cloud](https://meilisearch.com/cloud) offers a [user-friendly graphical interface for managing index settings](/learn/configuration/configuring_index_settings) in addition to the `/settings` route. The Cloud interface offers more immediate and visible feedback, and is helpful for tweaking relevancy when used in conjunction with the [search preview](/learn/getting_started/search_preview).

## Settings object

By default, the settings object looks like this. All fields are modifiable.

```json theme={null}
{
  "displayedAttributes": [
    "*"
  ],
  "searchableAttributes": [
    "*"
  ],
  "filterableAttributes": [],
  "sortableAttributes": [],
  "rankingRules":
  [
    "words",
    "typo",
    "proximity",
    "attribute",
    "sort",
    "exactness"
  ],
  "stopWords": [],
  "nonSeparatorTokens": [],
  "separatorTokens": [],
  "dictionary": [],
  "synonyms": {},
  "distinctAttribute": null,
  "typoTolerance": {
    "enabled": true,
    "minWordSizeForTypos": {
      "oneTypo": 5,
      "twoTypos": 9
    },
    "disableOnWords": [],
    "disableOnAttributes": []
  },
  "faceting": {
    "maxValuesPerFacet": 100
  },
  "pagination": {
    "maxTotalHits": 1000
  },
  "proximityPrecision": "byWord",
  "facetSearch": true,
  "prefixSearch": "indexingTime",
  "searchCutoffMs": null,
  "embedders": {},
  "chat": {},
  "vectorStore": "stable"
}
```

## All settings

This route allows you to retrieve, configure, or reset all of an index's settings at once.

### Get settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings" />

Get the settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/movies/settings'
  ```

  ```javascript JS theme={null}
  client.index('movies').getSettings()
  ```

  ```python Python theme={null}
  client.index('movies').get_settings()
  ```

  ```php PHP theme={null}
  $client->index('movies')->getSettings();
  ```

  ```java Java theme={null}
  client.index("movies").getSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').settings
  ```

  ```go Go theme={null}
  client.Index("movies").GetSettings()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").GetSettingsAsync();
  ```

  ```rust Rust theme={null}
  let settings: Settings = client
    .index("movies")
    .get_settings()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").getSettings { (result) in
      switch result {
      case .success(let setting):
          print(setting)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').getSettings();
  ```
</CodeGroup>

##### Response: `200 Ok`

```json theme={null}
{
  "displayedAttributes": [
    "*"
  ],
  "searchableAttributes": [
    "*"
  ],
  "filterableAttributes": [],
  "sortableAttributes": [],
  "rankingRules":
  [
    "words",
    "typo",
    "proximity",
    "attribute",
    "sort",
    "exactness"
  ],
  "stopWords": [],
  "nonSeparatorTokens": [],
  "separatorTokens": [],
  "dictionary": [],
  "synonyms": {},
  "distinctAttribute": null,
  "typoTolerance": {
    "enabled": true,
    "minWordSizeForTypos": {
      "oneTypo": 5,
      "twoTypos": 9
    },
    "disableOnWords": [],
    "disableOnAttributes": []
  },
  "faceting": {
    "maxValuesPerFacet": 100
  },
  "pagination": {
    "maxTotalHits": 1000
  },
  "proximityPrecision": "byWord",
  "facetSearch": true,
  "prefixSearch": "indexingTime",
  "searchCutoffMs": null,
  "embedders": {},
  "chat": {},
  "vectorStore": "stable"
}
```

### Update settings

<RouteHighlighter method="PATCH" path="/indexes/{index_uid}/settings" />

Update the settings of an index.

Passing `null` to an index setting will reset it to its default value.

Updates in the settings route are **partial**. This means that any parameters not provided in the body will be left unchanged.

If the provided index does not exist, it will be created.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

| Name                                                                                       | Type                        | Default value                                                                                         | Description                                                                      |
| :----------------------------------------------------------------------------------------- | :-------------------------- | :---------------------------------------------------------------------------------------------------- | :------------------------------------------------------------------------------- |
| **[`dictionary`](#dictionary)**                                                            | Array of strings            | Empty                                                                                                 | List of strings Meilisearch should parse as a single term                        |
| **[`displayedAttributes`](#displayed-attributes)**                                         | Array of strings            | All attributes: `["*"]`                                                                               | Fields displayed in the returned documents                                       |
| **[`distinctAttribute`](#distinct-attribute)**                                             | String                      | `null`                                                                                                | Search returns documents with distinct (different) values of the given field     |
| **[`faceting`](#faceting)**                                                                | Object                      | [Default object](#faceting-object)                                                                    | Faceting settings                                                                |
| **[`filterableAttributes`](#filterable-attributes)**                                       | Array of strings or objects | Empty                                                                                                 | Attributes to use as filters and facets                                          |
| **[`pagination`](#pagination)**                                                            | Object                      | [Default object](#pagination-object)                                                                  | Pagination settings                                                              |
| **[`proximityPrecision`](#proximity-precision)**                                           | String                      | `"byWord"`                                                                                            | Precision level when calculating the proximity ranking rule                      |
| **[`facetSearch`](#facet-search)**                                                         | Boolean                     | `true`                                                                                                | Enable or disable [facet search](/reference/api/facet_search) functionality      |
| **[`prefixSearch`](#prefix-search)**                                                       | String                      | `"indexingTime"`                                                                                      | When Meilisearch should return results only matching the beginning of query      |
| **[`rankingRules`](#ranking-rules)**                                                       | Array of strings            | `["words",`<br />`"typo",`<br />`"proximity",`<br />`"attribute",`<br />`"sort",`<br />`"exactness"]` | List of ranking rules in order of importance                                     |
| **[`searchableAttributes`](#searchable-attributes)**                                       | Array of strings            | All attributes: `["*"]`                                                                               | Fields in which to search for matching query words sorted by order of importance |
| **[`searchCutoffMs`](#search-cutoff)**                                                     | Integer                     | `null`, or 1500ms                                                                                     | Maximum duration of a search query                                               |
| **[`separatorTokens`](#separator-tokens)**                                                 | Array of strings            | Empty                                                                                                 | List of characters delimiting where one term begins and ends                     |
| **[`nonSeparatorTokens`](#non-separator-tokens)**                                          | Array of strings            | Empty                                                                                                 | List of characters not delimiting where one term begins and ends                 |
| **[`sortableAttributes`](#sortable-attributes)**                                           | Array of strings            | Empty                                                                                                 | Attributes to use when sorting search results                                    |
| **[`stopWords`](#stop-words)**                                                             | Array of strings            | Empty                                                                                                 | List of words ignored by Meilisearch when present in search queries              |
| **[`synonyms`](#synonyms)**                                                                | Object                      | Empty                                                                                                 | List of associated words treated similarly                                       |
| **[`typoTolerance`](#typo-tolerance)**                                                     | Object                      | [Default object](#typo-tolerance-object)                                                              | Typo tolerance settings                                                          |
| **[`embedders`](#embedders)**                                                              | Object of objects           | [Default object](#embedders-object)                                                                   | Embedder required for performing meaning-based search queries                    |
| **[`chat`](#conversation)** <NoticeTag type="experimental" label="experimental" />         | Object                      | [Default object](#chat-object)                                                                        | Chat settings for performing conversation-based queries                          |
| **[`vector-store`](#vector-store)** <NoticeTag type="experimental" label="experimental" /> | String                      | `"stable"`                                                                                            | Vector store used for AI-powered search                                          |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PATCH 'MEILISEARCH_URL/indexes/movies/settings' \
    -H 'Content-Type: application/json' \
    --data-binary '{
      "rankingRules": [
        "words",
        "typo",
        "proximity",
        "attribute",
        "sort",
        "exactness",
        "release_date:desc",
        "rank:desc"
      ],
      "distinctAttribute": "movie_id",
      "searchableAttributes": [
        "title",
        "overview",
        "genres"
      ],
      "displayedAttributes": [
        "title",
        "overview",
        "genres",
        "release_date"
      ],
      "stopWords": [
        "the",
        "a",
        "an"
      ],
      "sortableAttributes": [
        "title",
        "release_date"
      ],
      "synonyms": {
        "wolverine": [
          "xmen",
          "logan"
      ],
        "logan": ["wolverine"]
      },
      "typoTolerance": {
        "minWordSizeForTypos": {
          "oneTypo": 8,
          "twoTypos": 10
        },
        "disableOnAttributes": ["title"]
      },
      "pagination": {
        "maxTotalHits": 5000
      },
      "faceting": {
        "maxValuesPerFacet": 200
      },
      "searchCutoffMs": 150
    }'
  ```

  ```javascript JS theme={null}
  client.index('movies').updateSettings({
      rankingRules: [
          'words',
          'typo',
          'proximity',
          'attribute',
          'sort',
          'exactness',
          'release_date:desc',
          'rank:desc'
      ],
      distinctAttribute: 'movie_id',
      searchableAttributes: [
          'title',
          'overview',
          'genres'
      ],
      displayedAttributes: [
          'title',
          'overview',
          'genres',
          'release_date'
      ],
      stopWords: [
          'the',
          'a',
          'an'
      ],
      sortableAttributes: [
        'title',
        'release_date'
      ],
      synonyms: {
          'wolverine': ['xmen', 'logan'],
          'logan': ['wolverine']
      },
      typoTolerance: {
          'minWordSizeForTypos': {
              'oneTypo': 8,
              'twoTypos': 10
          },
          'disableOnAttributes': [
              'title'
          ]
      },
      pagination: {
          maxTotalHits: 5000
      },
      faceting: {
          maxValuesPerFacet: 200
      },
      searchCutoffMs: 150
  })
  ```

  ```python Python theme={null}
  client.index('movies').update_settings({
    'rankingRules': [
      'words',
      'typo',
      'proximity',
      'attribute',
      'sort',
      'exactness',
      'release_date:desc',
      'rank:desc'
    ],
    'distinctAttribute': 'movie_id',
    'searchableAttributes': [
      'title',
      'overview',
      'genres'
    ],
    'displayedAttributes': [
      'title',
      'overview',
      'genres',
      'release_date'
    ],
    'sortableAttributes': [
      'title',
      'release_date'
    ],
    'stopWords': [
      'the',
      'a',
      'an'
    ],
    'synonyms': {
      'wolverine': ['xmen', 'logan'],
      'logan': ['wolverine']
    },
    'typoTolerance': {
      'minWordSizeForTypos': {
          'oneTypo': 8,
          'twoTypos': 10
      },
      'disableOnAttributes': ['title']
    },
    'pagination': {
      'maxTotalHits': 5000
    },
    'faceting': {
      'maxValuesPerFacet': 200
    },
    'searchCutoffMs': 150
  })
  ```

  ```php PHP theme={null}
  $client->index('movies')->updateSettings([
    'rankingRules' => [
      'words',
      'typo',
      'proximity',
      'attribute',
      'sort',
      'exactness',
      'release_date:desc',
      'rank:desc'
    ],
    'distinctAttribute' => 'movie_id',
    'searchableAttributes' => [
      'title',
      'overview',
      'genres'
    ],
    'displayedAttributes' => [
      'title',
      'overview',
      'genres',
      'release_date'
    ],
    'stopWords' => [
      'the',
      'a',
      'an'
    ],
    'sortableAttributes' => [
      'title',
      'release_date'
    ],
    'synonyms' => [
      'wolverine' => ['xmen', 'logan'],
      'logan' => ['wolverine']
    ],
    'typoTolerance' => [
        'minWordSizeForTypos' => [
          'oneTypo' => 8,
          'twoTypos' => 10
        ],
        'disableOnAttributes' => ['title']
    ],
    'pagination' => [
      'maxTotalHits' => 5000
    ],
    'faceting' => [
      'maxValuesPerFacet' => 200
    ],
    'searchCutoffMs' => 150
  ]);
  ```

  ```java Java theme={null}
  Settings settings = new Settings();
  settings.setRankingRules(
    new String[] {
        "words",
        "typo",
        "proximity",
        "attribute",
        "sort",
        "exactness",
        "release_date:desc",
        "rank:desc"
    });
  settings.setDistinctAttribute("movie_id");
  settings.setSearchableAttributes(
    new String[] {
      "title",
      "overview",
      "genres"
    });
  settings.setDisplayedAttributes(
    new String[] {
      "title",
      "overview",
      "genres",
      "release_date"
    });
  settings.setStopWords(
    new String[] {
      "the",
      "a",
      "an"
    });
  settings.setSortableAttributes(
    new String[] {
      "title",
      "release_date"
    });

  HashMap<String, String[]> synonyms = new HashMap<String, String[]>();
  synonyms.put("wolverine", new String[] {"xmen", "logan"});
  synonyms.put("logan", new String[] {"wolverine"});
  settings.setSynonyms(synonyms);

  HashMap<String, Integer> minWordSizeTypos =
    new HashMap<String, Integer>() {
      {
        put("oneTypo", 8);
        put("twoTypos", 10);
      }
    };
  TypoTolerance typoTolerance = new TypoTolerance();
  typoTolerance.setMinWordSizeForTypos(minWordSizeTypos);
  settings.setTypoTolerance(typoTolerance);
  settings.setSearchCutoffMs(150);
  client.index("movies").updateSettings(settings);
  ```

  ```ruby Ruby theme={null}
  client.index('movies').update_settings({
    ranking_rules: [
      'words',
      'typo',
      'proximity',
      'attribute',
      'sort',
      'exactness',
      'release_date:desc',
      'rank:desc'
    ],
    distinct_attribute: 'movie_id',
    searchable_attributes: [
      'title',
      'overview',
      'genres'
    ],
    displayed_attributes: [
      'title',
      'overview',
      'genres',
      'release_date'
    ],
    stop_words: [
      'the',
      'a',
      'an'
    ],
    sortable_attributes: [
      'title',
      'release_date'
    ],
    synonyms: {
      wolverine: ['xmen', 'logan'],
      logan: ['wolverine']
    },
    pagination: {
      max_total_hits: 5000
    },
    faceting: {
      max_values_per_facet: 200
    },
    search_cutoff_ms: 150
  })
  ```

  ```go Go theme={null}
  distinctAttribute := "movie_id"
  settings := meilisearch.Settings{
    RankingRules: []string{
      "words",
      "typo",
      "proximity",
      "attribute",
      "sort",
      "exactness",
      "release_date:desc",
      "rank:desc",
    },
    DistinctAttribute: &distinctAttribute,
    SearchableAttributes: []string{
      "title",
      "overview",
      "genres",
    },
    DisplayedAttributes: []string{
      "title",
      "overview",
      "genres",
      "release_date",
    },
    StopWords: []string{
      "the",
      "a",
      "an",
    },
    SortableAttributes: []string{
      "title",
      "release_date",
    },
    Synonyms: map[string][]string{
      "wolverine": []string{"xmen", "logan"},
      "logan":     []string{"wolverine"},
    },
    TypoTolerance: &meilisearch.TypoTolerance{
      MinWordSizeForTypos: meilisearch.MinWordSizeForTypos{
        OneTypo:  8,
        TwoTypos: 10,
      },
      DisableOnAttributes: []string{"title"},
    },
    Pagination: &meilisearch.Pagination{
      MaxTotalHits: 5000,
    },
    Faceting: &meilisearch.Faceting{
      MaxValuesPerFacet: 200,
    },
    SearchCutoffMs: 150,
  }
  client.Index("movies").UpdateSettings(&settings)
  ```

  ```csharp C# theme={null}
  Settings newSettings = new Settings
  {
    RankingRules = new string[]
    {
      "words",
      "typo",
      "proximity",
      "attribute",
      "sort",
      "exactness",
      "release_date:desc",
      "rank:desc"
    },
    DistinctAttribute = "movie_id",
    SearchableAttributes = new string[] { "title", "overview", "genres" },
    DisplayedAttributes = new string[] { "title", "overview", "genres", "release_date" },
    SortableAttributes = new string[] { "title", "release_date" },
    StopWords = new string[] { "the", "a", "an" },
    Synonyms = new Dictionary<string, IEnumerable<string>>
    {
        { "wolverine", new string[] { "xmen", "logan" } },
        { "logan", new string[] { "wolverine" } },
    },
    FilterableAttributes = new string[] { },
    TypoTolerance = new TypoTolerance
    {
        DisableOnAttributes = new string[] { "title" },
        MinWordSizeForTypos = new TypoTolerance.TypoSize
        {
            OneTypo = 8,
            TwoTypos = 10
        }
    },
    SearchCutoffMs = 150
  };
  TaskInfo task = await client.Index("movies").UpdateSettingsAsync(newFilters);
  ```

  ```rust Rust theme={null}
  let mut synonyms = std::collections::HashMap::new();
  synonyms.insert(String::from("wolverine"), vec!["xmen", "logan"]);
  synonyms.insert(String::from("logan"), vec!["wolverine"]);

  let min_word_size_for_typos = MinWordSizeForTypos {
    one_typo: Some(4),
    two_typos; Some(12)
  }
  let typo_tolerance = TypoToleranceSettings {
    enabled: Some(true),
    disable_on_attributes: Some(vec!["title".to_string()]),
    disable_on_words: Some(vec![])
    min_word_size_for_typos: Some(min_word_size_for_typos),
  };

  let settings = Settings::new()
    .with_ranking_rules([
      "words",
      "typo",
      "proximity",
      "attribute",
      "sort",
      "exactness",
      "release_date:desc",
      "rank:desc"
    ])
    .with_distinct_attribute(Some("movie_id"))
    .with_searchable_attributes([
      "title",
      "overview",
      "genres"
    ])
    .with_displayed_attributes([
      "title",
      "overview",
      "genres",
      "release_date"
    ])
    .with_stop_words([
      "the",
      "a",
      "an"
    ])
    .with_sortable_attributes([
      "title",
      "release_date"
    ])
    .with_synonyms(synonyms)
    .with_typo_tolerance(typo_tolerance)
    .with_search_cutoff(150);

  let task: TaskInfo = client
    .index("movies")
    .set_settings(&settings)
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  let settings = Setting(rankingRules: [
      "words",
      "typo",
      "proximity",
      "attribute",
      "sort",
      "exactness",
      "release_date:desc",
      "rank:desc"
  ], searchableAttributes: [
      "title",
      "overview",
      "genres"
  ], displayedAttributes: [
      "title",
      "overview",
      "genres",
      "release_date"
  ], stopWords: [
      "the",
      "a",
      "an"
  ], synonyms: [
      "wolverine": ["xmen", "logan"],
      "logan": ["wolverine"]
  ], distinctAttribute: "movie_id",
  sortableAttributes: [
      "title",
      "release_date"
  ])
  client.index("movies").updateSettings(settings) { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').updateSettings(
        IndexSettings(
          rankingRules: [
            'words',
            'typo',
            'proximity',
            'attribute',
            'sort',
            'exactness',
            'release_date:desc',
            'rank:desc'
          ],
          distinctAttribute: 'movie_id',
          searchableAttributes: ['title', 'overview', 'genres'],
          displayedAttributes: [
            'title',
            'overview',
            'genres',
            'release_date'
          ],
          stopWords: ['the', 'a', 'an'],
          sortableAttributes: ['title', 'release_date'],
          synonyms: {
            'wolverine': ['xmen', 'logan'],
            'logan': ['wolverine'],
          },
        ),
      );
  ```
</CodeGroup>

<Warning>
  If Meilisearch encounters an error when updating any of the settings in a request, it immediately stops processing the request and returns an error message. In this case, the database settings remain unchanged. The returned error message will only address the first error encountered.
</Warning>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset settings

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings" />

Reset all the settings of an index to their [default value](#settings-object).

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/movies/settings'
  ```

  ```javascript JS theme={null}
  client.index('movies').resetSettings()
  ```

  ```python Python theme={null}
  client.index('movies').reset_settings()
  ```

  ```php PHP theme={null}
  $client->index('movies')->resetSettings();
  ```

  ```java Java theme={null}
  client.index("movies").resetSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').reset_settings
  ```

  ```go Go theme={null}
  client.Index("movies").ResetSettings()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").ResetSettingsAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("movies")
    .reset_settings()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").resetSettings { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').resetSettings();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Dictionary

Allows users to instruct Meilisearch to consider groups of strings as a single term by adding a supplementary dictionary of user-defined terms.

This is particularly useful when working with datasets containing many domain-specific words, and in languages where words are not separated by whitespace such as Japanese.

Custom dictionaries are also useful in a few use-cases for space-separated languages, such as datasets with names such as `"J. R. R. Tolkien"` and `"W. E. B. Du Bois"`.

<Tip>
  User-defined dictionaries can be used together with synonyms. It can be useful to configure Meilisearch so different spellings of an author's initials return the same results:

  ```json theme={null}
  "dictionary": ["W. E. B.", "W.E.B."],
  "synonyms": {
    "W. E. B.": ["W.E.B."],
    "W.E.B.": ["W. E. B."]
  }
  ```
</Tip>

### Get dictionary

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/dictionary" />

Get an index's user-defined dictionary.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/books/settings/dictionary'
  ```

  ```javascript JS theme={null}
  client.index('books').getDictionary()
  ```

  ```python Python theme={null}
  client.index('books').get_dictionary()
  ```

  ```php PHP theme={null}
  $client->index('books')->getDictionary();
  ```

  ```java Java theme={null}
  client.index("books").getDictionarySettings();
  ```

  ```ruby Ruby theme={null}
  client.index('books').dictionary
  ```

  ```go Go theme={null}
  client.Index("books").GetDictionary()
  ```

  ```csharp C# theme={null}
  var indexDictionary = await client.Index("books").GetDictionaryAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index('books')
    .get_dictionary()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("books").getDictionary { result in
    // handle result
  }
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
[]
```

### Update dictionary

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/dictionary" />

Update an index's user-defined dictionary.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```json theme={null}
["J. R. R.", "W. E. B."]
```

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/books/settings/dictionary' \
    -H 'Content-Type: application/json' \
    --data-binary '[
      "J. R. R.",
      "W. E. B."
    ]'
  ```

  ```javascript JS theme={null}
  client.index('books').updateDictionary(['J. R. R.', 'W. E. B.'])
  ```

  ```python Python theme={null}
  client.index('books').update_dictionary(["J. R. R.", "W. E. B."])
  ```

  ```php PHP theme={null}
  $client->index('books')->updateDictionary(['J. R. R.', 'W. E. B.']);
  ```

  ```java Java theme={null}
  client.index("books").updateDictionarySettings(new String[] {"J. R. R.", "W. E. B."});
  ```

  ```ruby Ruby theme={null}
  client.index('books').update_dictionary(['J. R. R.', 'W. E. B.'])
  ```

  ```go Go theme={null}
  client.Index("books").UpdateDictionary([]string{
    "J. R. R.",
    "W. E. B.",
  })
  ```

  ```csharp C# theme={null}
  var newDictionary = new string[] { "J. R. R.", "W. E. B." };
  await client.Index("books").UpdateDictionaryAsync(newDictionary);
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index('books')
    .set_dictionary(['J. R. R.', 'W. E. B.'])
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("books").updateDictionary(["J. R. R.", "W. E. B."]) { result in
    // handle result
  }
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2023-09-11T15:39:06.073314Z"
}
```

Use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset dictionary

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/dictionary" />

Reset an index's dictionary to its default value, `[]`.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/books/settings/dictionary'
  ```

  ```javascript JS theme={null}
  client.index('books').resetDictionary()
  ```

  ```python Python theme={null}
  client.index('books').reset_dictionary()
  ```

  ```php PHP theme={null}
  $client->index('books')->resetDictionary();
  ```

  ```java Java theme={null}
  client.index("books").resetDictionarySettings();
  ```

  ```ruby Ruby theme={null}
  client.index('books').reset_dictionary
  ```

  ```go Go theme={null}
  client.Index("books").ResetDictionary()
  ```

  ```csharp C# theme={null}
  await client.Index("books").ResetDictionaryAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index('books')
    .reset_dictionary()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("books").resetDictionary { result in
    // handle result
  }
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:53:32.863107Z"
}
```

Use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Displayed attributes

The attributes added to the `displayedAttributes` list appear in search results. `displayedAttributes` only affects the search endpoints. It has no impact on the [get documents with POST](/reference/api/documents#get-documents-with-post) and [get documents with GET](/reference/api/documents#get-documents-with-get) endpoints.

By default, the `displayedAttributes` array is equal to all fields in your dataset. This behavior is represented by the value `["*"]`.

[To learn more about displayed attributes, refer to our dedicated guide.](/learn/relevancy/displayed_searchable_attributes#displayed-fields)

### Get displayed attributes

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/displayed-attributes" />

Get the displayed attributes of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/movies/settings/displayed-attributes'
  ```

  ```javascript JS theme={null}
  client.index('movies').getDisplayedAttributes()
  ```

  ```python Python theme={null}
  client.index('movies').get_displayed_attributes()
  ```

  ```php PHP theme={null}
  $client->index('movies')->getDisplayedAttributes();
  ```

  ```java Java theme={null}
  client.index("movies").getDisplayedAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').get_displayed_attributes
  ```

  ```go Go theme={null}
  client.Index("movies").GetDisplayedAttributes()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").GetDisplayedAttributesAsync();
  ```

  ```rust Rust theme={null}
  let displayed_attributes: Vec<String> = client
    .index("movies")
    .get_displayed_attributes()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").getDisplayedAttributes { (result) in
      switch result {
      case .success(let displayedAttributes):
          print(displayedAttributes)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').getDisplayedAttributes();
  ```
</CodeGroup>

##### Response: `200 Ok`

```json theme={null}
[
  "title",
  "overview",
  "genres",
  "release_date.year"
]
```

### Update displayed attributes

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/displayed-attributes" />

Update the displayed attributes of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
[<String>, <String>, …]
```

An array of strings. Each string should be an attribute that exists in the selected index.

If an attribute contains an object, you can use dot notation to specify one or more of its keys, for example, `"displayedAttributes": ["release_date.year"]`.

<Warning>
  If the field does not exist, no error will be thrown.
</Warning>

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/movies/settings/displayed-attributes' \
    -H 'Content-Type: application/json' \
    --data-binary '[
      "title",
      "overview",
      "genres",
      "release_date"
    ]'
  ```

  ```javascript JS theme={null}
  client.index('movies').updateDisplayedAttributes([
    'title',
    'overview',
    'genres',
    'release_date'
  ])
  ```

  ```python Python theme={null}
  client.index('movies').update_displayed_attributes([
      'title',
      'overview',
      'genres',
      'release_date'
  ])
  ```

  ```php PHP theme={null}
  $client->index('movies')->updateDisplayedAttributes([
    'title',
    'overview',
    'genres',
    'release_date'
  ]);
  ```

  ```java Java theme={null}
  client.index("movies").updateDisplayedAttributesSettings(new String[]
  {
    "title",
    "overview",
    "genres",
    "release_date"
  });
  ```

  ```ruby Ruby theme={null}
  client.index('movies').update_displayed_attributes([
    'title',
    'overview',
    'genres',
    'release_date'
  ])
  ```

  ```go Go theme={null}
  displayedAttributes := []string{
    "title",
    "overview",
    "genres",
    "release_date",
  }
  client.Index("movies").UpdateDisplayedAttributes(&displayedAttributes)
  ```

  ```csharp C# theme={null}
  await client.Index("movies").UpdateDisplayedAttributesAsync(new[]
  {
    "title",
    "overview",
    "genres",
    "release_date"
  });
  ```

  ```rust Rust theme={null}
  let displayed_attributes = [
    "title",
    "overview",
    "genres",
    "release_date"
  ];

  let task: TaskInfo = client
    .index("movies")
    .set_displayed_attributes(&displayed_attributes)
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  let displayedAttributes: [String] = ["title", "overview", "genres", "release_date"]
  client.index("movies").updateDisplayedAttributes(displayedAttributes) { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').updateDisplayedAttributes([
    'title',
    'overview',
    'genres',
    'release_date',
  ]);
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset displayed attributes

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/displayed-attributes" />

Reset the displayed attributes of the index to the default value.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/movies/settings/displayed-attributes'
  ```

  ```javascript JS theme={null}
  client.index('movies').resetDisplayedAttributes()
  ```

  ```python Python theme={null}
  client.index('movies').reset_displayed_attributes()
  ```

  ```php PHP theme={null}
  $client->index('movies')->resetDisplayedAttributes();
  ```

  ```java Java theme={null}
  client.index("movies").resetDisplayedAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').reset_displayed_attributes
  ```

  ```go Go theme={null}
  client.Index("movies").ResetDisplayedAttributes()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").ResetDisplayedAttributesAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("movies")
    .reset_displayed_attributes()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").resetDisplayedAttributes { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').resetDisplayedAttributes();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Distinct attribute

The distinct attribute is a field whose value will always be unique in the returned documents.

<Warning>
  Updating distinct attributes will re-index all documents in the index, which can take some time. We recommend updating your index settings first and then adding documents as this reduces RAM consumption.
</Warning>

[To learn more about the distinct attribute, refer to our dedicated guide.](/learn/relevancy/distinct_attribute)

### Get distinct attribute

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/distinct-attribute" />

Get the distinct attribute of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/shoes/settings/distinct-attribute'
  ```

  ```javascript JS theme={null}
  client.index('shoes').getDistinctAttribute()
  ```

  ```python Python theme={null}
  client.index('shoes').get_distinct_attribute()
  ```

  ```php PHP theme={null}
  $client->index('shoes')->getDistinctAttribute();
  ```

  ```java Java theme={null}
  client.index("shoes").getDistinctAttributeSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('shoes').distinct_attribute
  ```

  ```go Go theme={null}
  client.Index("shoes").GetDistinctAttribute()
  ```

  ```csharp C# theme={null}
  string result = await client.Index("shoes").GetDistinctAttributeAsync();
  ```

  ```rust Rust theme={null}
  let distinct_attribute: Option<String> = client
    .index("shoes")
    .get_distinct_attribute()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("shoes").getDistinctAttribute { (result) in
      switch result {
      case .success(let distinctAttribute):
          print(distinctAttribute)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('shoes').getDistinctAttribute();
  ```
</CodeGroup>

##### Response: `200 Ok`

```json theme={null}
"skuid"
```

### Update distinct attribute

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/distinct-attribute" />

Update the distinct attribute field of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
<String>
```

A string. The string should be an attribute that exists in the selected index.

If an attribute contains an object, you can use dot notation to set one or more of its keys as a value for this setting, for example, `"distinctAttribute": "product.skuid"`.

<Warning>
  If the field does not exist, no error will be thrown.
</Warning>

[To learn more about the distinct attribute, refer to our dedicated guide.](/learn/relevancy/distinct_attribute)

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/shoes/settings/distinct-attribute' \
    -H 'Content-Type: application/json' \
    --data-binary '"skuid"'
  ```

  ```javascript JS theme={null}
  client.index('shoes').updateDistinctAttribute('skuid')
  ```

  ```python Python theme={null}
  client.index('shoes').update_distinct_attribute('skuid')
  ```

  ```php PHP theme={null}
  $client->index('shoes')->updateDistinctAttribute('skuid');
  ```

  ```java Java theme={null}
  client.index("shoes").updateDistinctAttributeSettings("skuid");
  ```

  ```ruby Ruby theme={null}
  client.index('shoes').update_distinct_attribute('skuid')
  ```

  ```go Go theme={null}
  client.Index("shoes").UpdateDistinctAttribute("skuid")
  ```

  ```csharp C# theme={null}
  TaskInfo result = await client.Index("shoes").UpdateDistinctAttributeAsync("skuid");
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("shoes")
    .set_distinct_attribute("skuid")
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("shoes").updateDistinctAttribute("skuid") { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('shoes').updateDistinctAttribute('skuid');
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset distinct attribute

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/distinct-attribute" />

Reset the distinct attribute of an index to its default value.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/shoes/settings/distinct-attribute'
  ```

  ```javascript JS theme={null}
  client.index('shoes').resetDistinctAttribute()
  ```

  ```python Python theme={null}
  client.index('shoes').reset_distinct_attribute()
  ```

  ```php PHP theme={null}
  $client->index('shoes')->resetDistinctAttribute();
  ```

  ```java Java theme={null}
  client.index("shoes").resetDistinctAttributeSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('shoes').reset_distinct_attribute
  ```

  ```go Go theme={null}
  client.Index("shoes").ResetDistinctAttribute()
  ```

  ```csharp C# theme={null}
  TaskInfo result = await client.Index("shoes").ResetDistinctAttributeAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("shoes")
    .reset_distinct_attribute()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("shoes").resetDistinctAttribute { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('shoes').resetDistinctAttribute();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Faceting

With Meilisearch, you can create [faceted search interfaces](/learn/filtering_and_sorting/search_with_facet_filters). This setting allows you to:

* Define the maximum number of values returned by the `facets` search parameter
* Sort facet values by value count or alphanumeric order

[To learn more about faceting, refer to our dedicated guide.](/learn/filtering_and_sorting/search_with_facet_filters)

### Faceting object

| Name                    | Type    | Default value                                                                | Description                                                                                                  |
| :---------------------- | :------ | :--------------------------------------------------------------------------- | :----------------------------------------------------------------------------------------------------------- |
| **`maxValuesPerFacet`** | Integer | `100`                                                                        | Maximum number of facet values returned for each facet. Values are sorted in ascending lexicographical order |
| **`sortFacetValuesBy`** | Object  | All facet values are sorted in ascending alphanumeric order (`"*": "alpha"`) | Customize facet order to sort by descending value count (`count`) or ascending alphanumeric order (`alpha`)  |

### Get faceting settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/faceting" />

Get the faceting settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/books/settings/faceting'
  ```

  ```javascript JS theme={null}
  client.index('books').getFaceting()
  ```

  ```python Python theme={null}
  client.index('books').get_faceting_settings()
  ```

  ```php PHP theme={null}
  $client->index('books')->getFaceting();
  ```

  ```java Java theme={null}
  client.index("books").getFacetingSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('books').faceting
  ```

  ```go Go theme={null}
  client.Index("books").GetFaceting()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").GetFacetingAsync();
  ```

  ```rust Rust theme={null}
  let faceting: FacetingSettings = client
    .index("books")
    .get_faceting()
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client.index('movies').getFaceting();
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
{
  "maxValuesPerFacet": 100,
  "sortFacetValuesBy": {
    "*": "alpha"
  }
}
```

### Update faceting settings

<RouteHighlighter method="PATCH" path="/indexes/{index_uid}/settings/faceting" />

Partially update the faceting settings for an index. Any parameters not provided in the body will be left unchanged.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
{
  "maxValuesPerFacet": <Integer>,
  "sortFacetValuesBy": {
      <String>: "count",
      <String>: "alpha"
  }
}
```

| Name                    | Type    | Default value                                                                | Description                                                                                                  |
| :---------------------- | :------ | :--------------------------------------------------------------------------- | :----------------------------------------------------------------------------------------------------------- |
| **`maxValuesPerFacet`** | Integer | `100`                                                                        | Maximum number of facet values returned for each facet. Values are sorted in ascending lexicographical order |
| **`sortFacetValuesBy`** | Object  | All facet values are sorted in ascending alphanumeric order (`"*": "alpha"`) | Customize facet order to sort by descending value count(`count`) or ascending alphanumeric order (`alpha`)   |

Suppose a query's search results contain a total of three values for a `colors` facet: `blue`, `green`, and `red`. If you set `maxValuesPerFacet` to `2`, Meilisearch will only return `blue` and `green` in the response body's `facetDistribution` object.

<Note>
  Setting `maxValuesPerFacet` to a high value might negatively impact performance.
</Note>

#### Example

The following code sample sets `maxValuesPerFacet` to `2`, sorts the `genres` facet by descending count, and all other facets in ascending alphanumeric order:

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PATCH 'MEILISEARCH_URL/indexes/books/settings/faceting' \
    -H 'Content-Type: application/json' \
    --data-binary '{
      "maxValuesPerFacet": 2,
      "sortFacetValuesBy": {
        "*": "alpha",
        "genres": "count"
      }
    }'
  ```

  ```javascript JS theme={null}
  client.index('books').updateFaceting({
    maxValuesPerFacet: 2
    sortFacetValuesBy: {
      '*': 'alpha',
      genres: 'count'
    }
  })
  ```

  ```python Python theme={null}
  params = {
    'maxValuesPerFacet': 2,
    'sortFacetValuesBy': {
        '*': 'count',
        'genres': 'count'
      }
  }
  client.index('books').update_faceting_settings(params)
  ```

  ```php PHP theme={null}
  $client->index('books')->updateFaceting([
    'maxValuesPerFacet' => 2,
    'sortFacetValuesBy' => ['*' => 'alpha', 'genres' => 'count']
  ]);
  ```

  ```java Java theme={null}
  Faceting newFaceting = new Faceting();
  newFaceting.setMaxValuesPerFacet(2);
  HashMap<String, FacetSortValue> facetSortValues = new HashMap<>();
  facetSortValues.put("*", FacetSortValue.ALPHA);
  facetSortValues.put("genres", FacetSortValue.COUNT);
  newFaceting.setSortFacetValuesBy(facetSortValues);
  client.index("books").updateFacetingSettings(newFaceting);
  ```

  ```ruby Ruby theme={null}
  client.index('books').update_faceting({
    max_values_per_facet: 2,
    sort_facet_values_by: {
      '*': 'alpha',
      genres: 'count'
    }
  })
  ```

  ```go Go theme={null}
  client.Index("books").UpdateFaceting(&meilisearch.Faceting{
      MaxValuesPerFacet: 2,
      SortFacetValuesBy: {
         "*":      SortFacetTypeAlpha,
         "genres": SortFacetTypeCount,
      }
  })
  ```

  ```csharp C# theme={null}
  var faceting = new Faceting
  {
      MaxValuesPerFacet = 2,
      SortFacetValuesBy = new Dictionary<string, SortFacetValuesByType>
      {
          ["*"] = SortFacetValuesByType.Alpha,
          ["genres"] = SortFacetValuesByType.Count
      }
  };
  await client.Index("books").UpdateFacetingAsync(faceting);
  ```

  ```rust Rust theme={null}
  let mut facet_sort_setting = BTreeMap::new();
  facet_sort_setting.insert(String::from("*"), FacetSortValue::Alpha);
  facet_sort_setting.insert(String::from("genres"), FacetSortValue::Count);
  let mut faceting = FacetingSettings {
    max_values_per_facet: 2,
    sort_facet_values_by: Some(facet_sort_setting),
  };

  let task: TaskInfo = client
    .index("books")
    .set_faceting(&faceting)
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client.index('books').updateFaceting(Faceting(
          maxValuesPerFacet: 2,
          sortFacetValuesBy: {
            '*': FacetingSortTypes.alpha,
            'genres': FacetingSortTypes.count
          }));
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:56:44.991039Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset faceting settings

Reset an index's faceting settings to their [default value](#faceting-object). Setting `sortFacetValuesBy` to `null`(`--data-binary '{ "sortFacetValuesBy": null }'`), will restore it to the default value (`"*": "alpha"`).

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/books/settings/faceting'
  ```

  ```javascript JS theme={null}
  client.index('books').resetFaceting()
  ```

  ```python Python theme={null}
  client.index('books').reset_faceting_settings()
  ```

  ```php PHP theme={null}
  $client->index('books')->resetFaceting();
  ```

  ```java Java theme={null}
  client.index("books").resetFacetingSettings();
  ```

  ```ruby Ruby theme={null}
  index('books').reset_faceting
  ```

  ```go Go theme={null}
  client.Index("books").ResetFaceting()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").ResetFacetingAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("books")
    .reset_faceting()
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client.index('movies').resetFaceting();
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:53:32.863107Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Filterable attributes

Attributes in the `filterableAttributes` list can be used as [filters](/learn/filtering_and_sorting/filter_search_results) or [facets](/learn/filtering_and_sorting/search_with_facet_filters).

<Warning>
  Updating filterable attributes will re-index all documents in the index, which can take some time. To reduce RAM consumption, first update your index settings and then add documents.
</Warning>

### Filterable attribute object

`filterableAttributes` may be an array of either strings or filterable attribute objects.

Filterable attribute objects must contain the following fields:

| Name                    | Type             | Default value                                                              | Description                                                        |
| ----------------------- | ---------------- | -------------------------------------------------------------------------- | ------------------------------------------------------------------ |
| **`attributePatterns`** | Array of strings | `[]`                                                                       | A list of strings indicating filterable fields                     |
| **`features`**          | Object           | `{"facetSearch": false, "filter": {"equality": true, "comparison": false}` | A list outlining filter types enabled for the specified attributes |

#### `attributePatterns`

Attribute patterns may begin or end with a \* wildcard to match multiple fields: `customer_*`, `attribute*`.

#### `features`

`features` allows you to decide which filter features are allowed for the specified attributes. It accepts the following fields:

* `facetSearch`: Whether facet search should be enabled for the specified attributes. Boolean, defaults to `false`
* `filter`: A list outlining the filter types for the specified attributes. Must be an object and accepts the following fields:
  * `equality`: Enables `=`, `!=`, `IN`, `EXISTS`, `IS NULL`, `IS EMPTY`, `NOT`, `AND`, and `OR`. Boolean, defaults to `true`
  * `comparison`: Enables `>`, `>=`, `<`, `<=`, `TO`, `EXISTS`, `IS NULL`, `IS EMPTY`, `NOT`, `AND`, and `OR`. Boolean, defaults to `false`

Calculating `comparison` filters is a resource-intensive operation. Disabling them may lead to better search and indexing performance. `equality` filters use fewer resources and have limited impact on performance.

<Warning>
  #### Filterable attributes and reserved attributes

  Use the simple string syntax to match reserved attributes. Reserved Meilisearch fields are always prefixed with an underscore (`_`), such as `_geo` and `_vector`.

  If set as a filterable attribute, reserved attributes ignore the `features` field and automatically activate all search features. Reserved fields will not be matched by wildcard `attributePatterns` such as `_*`.
</Warning>

### Get filterable attributes

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/filterable-attributes" />

Get the filterable attributes for an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/movies/settings/filterable-attributes'
  ```

  ```javascript JS theme={null}
  client.index('movies').getFilterableAttributes()
  ```

  ```python Python theme={null}
  client.index('movies').get_filterable_attributes()
  ```

  ```php PHP theme={null}
  $client->index('movies')->getFilterableAttributes();
  ```

  ```java Java theme={null}
  client.index("movies").getFilterableAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').filterable_attributes
  ```

  ```go Go theme={null}
  client.Index("movies").GetFilterableAttributes()
  ```

  ```csharp C# theme={null}
  IEnumerable<string> attributes = await client.Index("movies").GetFilterableAttributesAsync();
  ```

  ```rust Rust theme={null}
  let filterable_attributes: Vec<String> = client
    .index("movies")
    .get_filterable_attributes()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").getFilterableAttributes { (result) in
      switch result {
      case .success(let attributes):
          print(attributes)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').getFilterableAttributes();
  ```
</CodeGroup>

##### Response: `200 Ok`

```json theme={null}
[
  "genres",
  "director",
  "release_date.year"
]
```

### Update filterable attributes

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/filterable-attributes" />

Update an index's filterable attributes list.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
[<String>, <String>, …]
```

An array of strings containing the attributes that can be used as filters at query time. All filter types are enabled for the specified attributes when using the array of strings format.

You may also use an array of objects:

```
[
  {
    "attributePatterns": [<String>, <String>, …],
    "features": {
      "facetSearch": <Boolean>,
      "filter": {
        "equality": <Boolean>,
        "comparison": <Boolean>
      }
    }
  }
]
```

If the specified field does not exist, Meilisearch will silently ignore it.

If an attribute contains an object, you can use dot notation to set one or more of its keys as a value for this setting: `"filterableAttributes": ["release_date.year"]` or `"attributePatterns": ["release_date.year"]`.

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/movies/settings/filterable-attributes' \
    -H 'Content-Type: application/json' \
    --data-binary '[
      "genres",
      "director",
      {
        "attributePatterns": ["*_ratings"],
        "features": {
          "facetSearch": false,
          "filter": {
            "equality": true,
            "comparison": false
          }
        }
      }
    ]'
  ```

  ```javascript JS theme={null}
  client.index('movies')
    .updateFilterableAttributes([
      "genres",
      {
        attributePatterns: ["genre"],
        features: {
          facetSearch: true,
          filter: { equality: true, comparison: false },
        },
      }
    ])
  ```

  ```python Python theme={null}
  client.index('movies').update_filterable_attributes([
    'genres',
    'director'
  ])
  ```

  ```php PHP theme={null}
  $client->index('movies')->updateFilterableAttributes([
    'author',
    [
        'attributePatterns' => ['genres'],
        'features' => [
            'facetSearch' => true,
            'filter' => [
                'equality' => true,
                'comparison' => false,
            ],
        ],
    ],
  ]);
  ```

  ```java Java theme={null}
  Settings settings = new Settings();
  settings.setFilterableAttributes(new String[] {"genres", "director"});
  client.index("movies").updateSettings(settings);
  ```

  ```ruby Ruby theme={null}
  client.index('movies').update_filterable_attributes([
    'genres',
    'director'
  ])
  ```

  ```go Go theme={null}
  filterableAttributes := []interface{}{
    "genres",
    "director",
    AttributeRule{
      AttributePatterns: []string{"tag"}
      Features: AttributeFeatures{
        FacetSearch: false,
        Filter: FilterFeatures{
          Equality:   true,
          Comparison: false,
        }
      }
    },
    map[string]interface{}{
      "attributePatterns": []interface{}{"year"}
      "features": map[string]interface{}{
        "facetSearch": false,
        "filter": map[string]interface{}{
          "equality":   true,
          "comparison": true,
        }
      }
    }
  }
  client.Index("movies").UpdateFilterableAttributes(&filterableAttributes)
  ```

  ```csharp C# theme={null}
  List<string> attributes = new() { "genres", "director" };
  TaskInfo result = await client.Index("movies").UpdateFilterableAttributesAsync(attributes);
  ```

  ```rust Rust theme={null}
  let filterable_attributes = [
    "genres",
    "director"
  ];

  let task: TaskInfo = client
    .index("movies")
    .set_filterable_attributes(&filterable_attributes)
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").updateFilterableAttributes(["genre", "director"]) { (result) in
      switch result {
      case .success(let task):
          print(task)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client
      .index('movies')
      .updateFilterableAttributes(['genres', 'director']);
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset filterable attributes

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/filterable-attributes" />

Reset an index's filterable attributes list back to its default value.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/movies/settings/filterable-attributes'
  ```

  ```javascript JS theme={null}
  client.index('movies').resetFilterableAttributes()
  ```

  ```python Python theme={null}
  client.index('movies').reset_filterable_attributes()
  ```

  ```php PHP theme={null}
  $client->index('movies')->resetFilterableAttributes();
  ```

  ```java Java theme={null}
  client.index("movies").resetFilterableAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('movies').reset_filterable_attributes
  ```

  ```go Go theme={null}
  client.Index("movies").ResetFilterableAttributes()
  ```

  ```csharp C# theme={null}
  TaskInfo result = await client.Index("movies").ResetFilterableAttributesAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("movies")
    .reset_filterable_attributes()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  client.index("movies").resetFilterableAttributes { (result) in
      switch result {
      case .success(let attributes):
          print(attributes)
      case .failure(let error):
          print(error)
      }
  }
  ```

  ```dart Dart theme={null}
  await client.index('movies').resetFilterableAttributes();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "movies",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2021-08-11T09:25:53.000000Z"
}
```

You can use this `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Localized attributes

By default, Meilisearch auto-detects the languages used in your documents. This setting allows you to explicitly define which languages are present in a dataset, and in which fields.

Localized attributes affect `searchableAttributes`, `filterableAttributes`, and `sortableAttributes`.

Configuring multiple languages for a single index may negatively impact performance.

<Note>
  [`locales`](/reference/api/search#query-locales) and `localizedAttributes` have the same goal: explicitly state the language used in a search when Meilisearch's language auto-detection is not working as expected.

  If you believe Meilisearch is detecting incorrect languages because of the query text, explicitly set the search language with `locales`.

  If you believe Meilisearch is detecting incorrect languages because of document, explicitly set the document language at the index level with `localizedAttributes`.

  For full control over the way Meilisearch detects languages during indexing and at search time, set both `locales` and `localizedAttributes`.
</Note>

### Localized attributes object

`localizedAttributes` must be an array of locale objects. Its default value is `[]`.

Locale objects must have the following fields:

| Name                    | Type             | Default value | Description                                                                   |
| :---------------------- | :--------------- | :------------ | :---------------------------------------------------------------------------- |
| **`locales`**           | Array of strings | `[]`          | A list of strings indicating one or more ISO-639 locales                      |
| **`attributePatterns`** | Array of strings | `[]`          | A list of strings indicating which fields correspond to the specified locales |

#### `locales`

Meilisearch supports the following [ISO-639-3](https://iso639-3.sil.org/) three-letter `locales`: `epo`, `eng`, `rus`, `cmn`, `spa`, `por`, `ita`, `ben`, `fra`, `deu`, `ukr`, `kat`, `ara`, `hin`, `jpn`, `heb`, `yid`, `pol`, `amh`, `jav`, `kor`, `nob`, `dan`, `swe`, `fin`, `tur`, `nld`, `hun`, `ces`, `ell`, `bul`, `bel`, `mar`, `kan`, `ron`, `slv`, `hrv`, `srp`, `mkd`, `lit`, `lav`, `est`, `tam`, `vie`, `urd`, `tha`, `guj`, `uzb`, `pan`, `aze`, `ind`, `tel`, `pes`, `mal`, `ori`, `mya`, `nep`, `sin`, `khm`, `tuk`, `aka`, `zul`, `sna`, `afr`, `lat`, `slk`, `cat`, `tgl`, `hye`.

You may alternatively use [ISO-639-1 two-letter equivalents](https://iso639-3.sil.org/code_tables/639/data) to the supported `locales`.

You may also assign an empty array to `locales`. In this case, Meilisearch will auto-detect the language of the associated `attributePatterns`.

#### `attributePatterns`

Attribute patterns may begin or end with a `*` wildcard to match multiple fields: `en_*`, `*-ar`.

You may also set `attributePatterns` to `*`, in which case Meilisearch will treat all fields as if they were in the associated locale.

### Get localized attributes settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/localized-attributes" />

Get the localized attributes settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/INDEX_NAME/settings/localized-attributes'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').getLocalizedAttributes()
  ```

  ```python Python theme={null}
  client.index('INDEX_NAME').get_localized_attributes()
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->getLocalizedAttributes();
  ```

  ```java Java theme={null}
  client.index("INDEX_NAME").getLocalizedAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_NAME').localized_attributes
  ```

  ```go Go theme={null}
  client.index("INDEX_NAME").GetLocalizedAttributes()
  ```

  ```rust Rust theme={null}
  let localized_attributes: Option<Vec<LocalizedAttributes>> = client
    .index("books")
    .get_localized_attributes()
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
[
  {"locales": ["jpn"], "attributePatterns": ["*_ja"]}
]
```

### Update localized attribute settings

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/localized-attributes" />

Update the localized attributes settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
[
  {
   "locales": [<String>, …],
   "attributePatterns": [<String>, …],
  }
]
```

| Name                      | Type             | Default value | Description                                                |
| :------------------------ | :--------------- | :------------ | :--------------------------------------------------------- |
| **`localizedAttributes`** | Array of objects | `[]`          | Explicitly set specific locales for one or more attributes |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/INDEX_NAME/settings/localized-attributes' \
    -H 'Content-Type: application/json' \
    --data-binary '[
      {"locales": ["jpn"], "attributePatterns": ["*_ja"]}
    ]'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').updateLocalizedAttributes([
    { attributePatterns: ['*_ja'], locales: ['jpn'] },
  ])
  ```

  ```python Python theme={null}
  client.index('INDEX_NAME').update_localized_attributes([
    {'attribute_patterns': ['*_ja'], 'locales': ['jpn']}
  ])
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->updateLocalizedAttributes([
    'locales' => ['jpn'],
    'attributePatterns' => ['*_ja']
  ]);
  ```

  ```java Java theme={null}
  LocalizedAttribute attribute = new LocalizedAttribute();
  attribute.setAttributePatterns(new String[] {"jpn"});
  attribute.setLocales(new String[] {"*_ja"});

  client.index("INDEX_NAME").updateLocalizedAttributesSettings(
    new LocalizedAttributes[] {attribute}
  );
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_NAME').update_localized_attributes([
    { attribute_patterns: ['*_ja'], locales: ['jpn'] },
  ])
  ```

  ```go Go theme={null}
  client.index("INDEX_NAME").UpdateLocalizedAttributes([]*LocalizedAttributes{
      { AttributePatterns: ["*_ja"], Locales: ["jpn"] },
  })
  ```

  ```rust Rust theme={null}
  let localized_attributes = vec![LocalizedAttributes {
      locales: vec!["jpn".to_string()],
      attribute_patterns: vec!["*_ja".to_string()],
  }];
  let task: TaskInfo = client
    .index("books")
    .set_localized_attributes(&localizced_attributes)
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "INDEX_NAME",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:56:44.991039Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset localized attributes settings

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/localized-attributes" />

Reset an index's localized attributes to their [default value](#localized-attributes-object).

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/INDEX_NAME/settings/localized-attributes'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').resetLocalizedAttributes()
  ```

  ```python Python theme={null}
  client.index('INDEX_NAME').reset_localized_attributes()
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->resetLocalizedAttributes();
  ```

  ```java Java theme={null}
  client.index("INDEX_NAME").resetLocalizedAttributesSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_NAME').reset_localized_attributes
  ```

  ```go Go theme={null}
  client.index("INDEX_NAME").ResetLocalizedAttributes()
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("books")
    .reset_localized_attributes()
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "INDEX_NAME",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:53:32.863107Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Pagination

To protect your database from malicious scraping, Meilisearch has a default limit of 1000 results per search. This setting allows you to configure the maximum number of results returned per search.

`maxTotalHits` takes priority over search parameters such as `limit`, `offset`, `hitsPerPage`, and `page`.

For example, if you set `maxTotalHits` to 100, you will not be able to access search results beyond 100 no matter the value configured for `offset`.

[To learn more about paginating search results with Meilisearch, refer to our dedicated guide.](/guides/front_end/pagination)

### Pagination object

| Name               | Type    | Default value | Description                                                 |
| :----------------- | :------ | :------------ | :---------------------------------------------------------- |
| **`maxTotalHits`** | Integer | `1000`        | The maximum number of search results Meilisearch can return |

<Danger>
  Setting `maxTotalHits` to a value higher than the default will negatively impact search performance. Setting `maxTotalHits` to values over `20000` may result in queries taking seconds to complete.
</Danger>

### Get pagination settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/pagination" />

Get the pagination settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/books/settings/pagination'
  ```

  ```javascript JS theme={null}
  client.index('books').getPagination()
  ```

  ```python Python theme={null}
  client.index('books').get_pagination_settings()
  ```

  ```php PHP theme={null}
  $client->index('books')->getPagination();
  ```

  ```java Java theme={null}
  client.index("books").getPaginationSettings();
  ```

  ```ruby Ruby theme={null}
  index('books').pagination
  ```

  ```go Go theme={null}
  client.Index("books").GetPagination()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").GetPaginationAsync();
  ```

  ```rust Rust theme={null}
  let pagination: PaginationSetting = client
    .index("books")
    .get_pagination()
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client.index('movies').getPagination();
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
{
  "maxTotalHits": 1000
}
```

### Update pagination settings

<RouteHighlighter method="PATCH" path="/indexes/{index_uid}/settings/pagination" />

Partially update the pagination settings for an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
{maxTotalHits: <Integer>}
```

| Name               | Type    | Default value | Description                                                 |
| :----------------- | :------ | :------------ | :---------------------------------------------------------- |
| **`maxTotalHits`** | Integer | `1000`        | The maximum number of search results Meilisearch can return |

<Danger>
  Setting `maxTotalHits` to a value higher than the default will negatively impact search performance. Setting `maxTotalHits` to values over `20000` may result in queries taking seconds to complete.
</Danger>

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PATCH 'MEILISEARCH_URL/indexes/books/settings/pagination' \
    -H 'Content-Type: application/json' \
    --data-binary '{
      "maxTotalHits": 100
    }'
  ```

  ```javascript JS theme={null}
  client.index('books').updateSettings({ pagination: { maxTotalHits: 100 }})
  ```

  ```python Python theme={null}
  client.index('books').update_pagination_settings({'maxTotalHits': 100})
  ```

  ```php PHP theme={null}
  $client->index('books')->updateSettings([
    'pagination' => [
      'maxTotalHits' => 100
    ]
  ]);
  ```

  ```java Java theme={null}
  Pagination newPagination = new Pagination();
  newPagination.setMaxTotalHits(100);
  client.index("books").updatePaginationSettings(newPagination);
  ```

  ```ruby Ruby theme={null}
  index('books').update_pagination({ max_total_hits: 100 })
  ```

  ```go Go theme={null}
  client.Index("books").UpdatePagination(&meilisearch.Pagination{
      MaxTotalHits: 100,
  })
  ```

  ```csharp C# theme={null}
  var pagination = new Pagination {
    MaxTotalHits = 20
  };
  await client.Index("movies").UpdatePaginationAsync(pagination);
  ```

  ```rust Rust theme={null}
  let pagination = PaginationSetting {max_total_hits:100};

  let task: TaskInfo = client
    .index("books")
    .set_pagination(pagination)
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client
      .index('books')
      .updatePagination(Pagination(maxTotalHits: 100));
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:56:44.991039Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset pagination settings

Reset an index's pagination settings to their [default value](#pagination-object).

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/books/settings/pagination'
  ```

  ```javascript JS theme={null}
  client.index('books').resetPagination()
  ```

  ```python Python theme={null}
  client.index('books').reset_pagination_settings()
  ```

  ```php PHP theme={null}
  $client->index('books')->resetPagination();
  ```

  ```java Java theme={null}
  client.index("books").resetPaginationSettings();
  ```

  ```ruby Ruby theme={null}
  index('books').reset_pagination
  ```

  ```go Go theme={null}
  client.Index("books").ResetPagination()
  ```

  ```csharp C# theme={null}
  await client.Index("movies").ResetPaginationAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("books")
    .reset_pagination()
    .await
    .unwrap();
  ```

  ```dart Dart theme={null}
  await client.index('movies').resetPagination();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2022-04-14T20:53:32.863107Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Proximity precision

Calculating the distance between words is a resource-intensive operation. Lowering the precision of this operation may significantly improve performance and will have little impact on result relevancy in most use-cases. Meilisearch uses word distance when [ranking results according to proximity](/learn/relevancy/ranking_rules#3-proximity) and when users perform [phrase searches](/reference/api/search#phrase-search).

`proximityPrecision` accepts one of the following string values:

* `"byWord"`: calculate the precise distance between query terms. Higher precision, but may lead to longer indexing time. This is the default setting
* `"byAttribute"`: determine if multiple query terms are present in the same attribute. Lower precision, but shorter indexing time

### Get proximity precision settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/proximity-precision" />

Get the proximity precision settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/books/settings/proximity-precision'
  ```

  ```javascript JS theme={null}
  client.index('books').getProximityPrecision()
  ```

  ```python Python theme={null}
  client.index('books').get_proximity_precision()
  ```

  ```php PHP theme={null}
  $client->index('books')->getProximityPrecision();
  ```

  ```java Java theme={null}
  client.index("books").getProximityPrecisionSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('books').proximity_precision
  ```

  ```go Go theme={null}
  client.Index("books").GetProximityPrecision()
  ```

  ```csharp C# theme={null}
  await client.Index("books").GetProximityPrecisionAsync();
  ```

  ```rust Rust theme={null}
  let proximity_precision: String = client
    .index("books")
    .get_proximity_precision()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  let precisionValue = try await self.client.index("books").getProximityPrecision()
  ```
</CodeGroup>

##### Response: `200 OK`

```
"byWord"
```

### Update proximity precision settings

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/proximity-precision" />

Update the pagination settings for an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
"byWord"|"byAttribute"
```

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/books/settings/proximity-precision' \
    -H 'Content-Type: application/json' \
    --data-binary '"byAttribute"'
  ```

  ```javascript JS theme={null}
  client.index('books').updateProximityPrecision('byAttribute')
  ```

  ```python Python theme={null}
  client.index('books').update_proximity_precision(ProximityPrecision.BY_ATTRIBUTE)
  ```

  ```php PHP theme={null}
  $client->index('books')->updateProximityPrecision('byAttribute');
  ```

  ```java Java theme={null}
  client.index("books").updateProximityPrecisionSettings("byAttribute");
  ```

  ```ruby Ruby theme={null}
  client.index('books').update_proximity_precision('byAttribute')
  ```

  ```go Go theme={null}
  client.Index("books").UpdateProximityPrecision(ByAttribute)
  ```

  ```csharp C# theme={null}
  await client.Index("books").UpdateProximityPrecisionAsync("byAttribute");
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("books")
    .set_proximity_precision("byAttribute".to_string())
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  let task = try await self.client.index("books").updateProximityPrecision(.byWord)
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2023-04-14T15:50:29.821044Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset proximity precision settings

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/proximity-precision" />

Reset an index's proximity precision setting to its default value.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/books/settings/proximity-precision'
  ```

  ```javascript JS theme={null}
  client.index('books').resetProximityPrecision()
  ```

  ```python Python theme={null}
  client.index('books').reset_proximity_precision()
  ```

  ```php PHP theme={null}
  $client->index('books')->resetProximityPrecision();
  ```

  ```java Java theme={null}
  client.index("books").resetProximityPrecisionSettings();
  ```

  ```ruby Ruby theme={null}
  client.index('books').reset_proximity_precision
  ```

  ```go Go theme={null}
  client.Index("books").ResetProximityPrecision()
  ```

  ```csharp C# theme={null}
  await client.Index("books").ResetProximityPrecisionAsync();
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index("books")
    .reset_proximity_precision()
    .await
    .unwrap();
  ```

  ```swift Swift theme={null}
  let task = try await self.client.index("books").resetProximityPrecision()
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "books",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2023-04-14T15:51:47.821044Z"
}
```

You can use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Facet search

Processing filterable attributes for facet search is a resource-intensive operation. This feature is enabled by default, but disabling it may speed up indexing.

`facetSearch` accepts a single Boolean value. If set to `false`, it disables facet search for the whole index. Meilisearch returns an error if you try to access the `/facet-search` endpoint when facet search is disabled.

### Get facet search settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/facet-search" />

Get the facet search settings of an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X GET 'MEILISEARCH_URL/indexes/INDEX_UID/settings/facet-search'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').getFacetSearch();
  ```

  ```python Python theme={null}
  client.index('books').get_facet_search_settings()
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->getFacetSearch();
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_UID').facet_search_setting
  ```

  ```go Go theme={null}
  client.Index("books").GetFacetSearch()
  ```

  ```rust Rust theme={null}
  let facet_search: bool = client
    .index(INDEX_UID)
    .get_facet_search()
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `200 OK`

```json theme={null}
true
```

### Update facet search settings

<RouteHighlighter method="PUT" path="/indexes/{index_uid}/settings/facet-search" />

Update the facet search settings for an index.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Body

```
<Boolean>
```

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X PUT 'MEILISEARCH_URL/indexes/INDEX_UID/settings/facet-search' \
    -H 'Content-Type: application/json' \
    --data-binary 'false'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').updateFacetSearch(false);
  ```

  ```python Python theme={null}
  client.index('books').update_facet_search_settings(False)
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->updateFacetSearch(false);
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_UID').update_facet_search_setting(false)
  ```

  ```go Go theme={null}
  client.Index("books").UpdateFacetSearch(false)
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index(INDEX_UID)
    .set_facet_search(false)
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "INDEX_UID",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2024-07-19T22:33:18.523881Z"
}
```

Use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

### Reset facet search settings

<RouteHighlighter method="DELETE" path="/indexes/{index_uid}/settings/facet-search" />

Reset an index's facet search to its default settings.

#### Path parameters

| Name               | Type   | Description                                                              |
| :----------------- | :----- | :----------------------------------------------------------------------- |
| **`index_uid`** \* | String | [`uid`](/learn/getting_started/indexes#index-uid) of the requested index |

#### Example

<CodeGroup>
  ```bash cURL theme={null}
  curl \
    -X DELETE 'MEILISEARCH_URL/indexes/INDEX_UID/settings/facet-search'
  ```

  ```javascript JS theme={null}
  client.index('INDEX_NAME').resetFacetSearch();
  ```

  ```python Python theme={null}
  client.index('books').reset_facet_search_settings()
  ```

  ```php PHP theme={null}
  $client->index('INDEX_NAME')->resetFacetSearch();
  ```

  ```ruby Ruby theme={null}
  client.index('INDEX_UID').reset_facet_search_setting
  ```

  ```go Go theme={null}
  client.Index("books").ResetFacetSearch()
  ```

  ```rust Rust theme={null}
  let task: TaskInfo = client
    .index(INDEX_UID)
    .reset_facet_search()
    .await
    .unwrap();
  ```
</CodeGroup>

##### Response: `202 Accepted`

```json theme={null}
{
  "taskUid": 1,
  "indexUid": "INDEX_UID",
  "status": "enqueued",
  "type": "settingsUpdate",
  "enqueuedAt": "2024-07-19T22:35:33.723983Z"
}
```

Use the returned `taskUid` to get more details on [the status of the task](/reference/api/tasks#get-one-task).

## Prefix search

Prefix search is the process through which Meilisearch matches documents that begin with a specific query term, instead of only exact matches. This is a resource-intensive operation that happens during indexing by default.

Use `prefixSearch` to change how prefix search works. It accepts one of the following strings:

* `"indexingTime"`: calculate prefix search during indexing. This is the default behavior
* `"disabled"`: do not calculate prefix search. May speed up indexing, but will severely impact search result relevancy

### Get prefix search settings

<RouteHighlighter method="GET" path="/indexes/{index_uid}/settings/prefix-search" />

Get the prefix search settings of an index.

#### Path parameters

[...]
